#include <vector>
#include <cstdio>

using namespace std;

/* como está é bom para poucas escritas e muitas leituras de faixas! */
struct FenwickTree {
    FenwickTree(int n) : data(n) {}
    
    int query(int start, int end) {
        if(start == 0) {
            int sum;
            for(sum = 0; end >= 0; end = (end & (end + 1)) - 1)
                sum += data[end];
                
            return sum;
        } else {
            return query(0, end) - query(0, start-1);
        }
    }
    
    void increase(int k, int inc) {
        for(int e = data.size(); k < e; k |= k + 1)
            data[k] += inc;
    }
    
    vector<int> data;
};

int main() {
    FenwickTree tree(5);
    tree.increase(0, 8);
    tree.increase(1, 2);
    tree.increase(2, 10);
    tree.increase(3, 8);
    tree.increase(4, 12);
    
    printf("query(0, 4) == %d\n", tree.query(0, 4) );
    printf("query(1, 3) == %d\n", tree.query(1, 3) );
    printf("query(2, 3) == %d\n", tree.query(2, 3) );
    
    return 0;
}
